  '                             Eamon-QB
  '
  '                        Dungeon Initialize
  '                           Version 4.01
  '
  '                          By John Nelson
  '
  ' =====================================================================
  '                   Log of Changes
  ' ---------------------------------------------------------------------
  '    4-6-00   Put error handling in for directory already created
  '             and change dir name to Adv# format (added '#') Also
  '             Added MAX.MON field to control file.
  ' =====================================================================
     KEY OFF
     ON ERROR GOTO NoColors
     OPEN "EAMCOLOR" FOR INPUT AS #1
     INPUT #1, fgc%
     INPUT #1, bgc%
     INPUT #1, hfg%
     INPUT #1, hbg%
     CLOSE
In.BW:
     ON ERROR GOTO 0
     COLOR fgc%, bgc%
     GOTO Colorset
NoColors:
      fgc% = 7
      bgc% = 0
      hfg% = 0
      hbg% = 7
      RESUME In.BW
Colorset:
      CLS
      PRINT SPC(20); "Eamon-QB Dungeon Initialization"
      PRINT SPC(20); "         Version 4.01          "
      LOCATE 6, 1
      PRINT "Creating Adventure in a subdirectory? (Y/N) ";
      A$ = ""
      WHILE A$ <> "Y" AND A$ <> "N"
        A$ = INPUT$(1)
        A$ = UCASE$(A$)
      WEND
      IF A$ = "N" THEN GOTO Froppy.Disk
      MakeDirSw = -1
      AdvDir$ = ""
      GOTO CREATE.FILES
Froppy.Disk:
      LOCATE 6, 1
      PRINT "Insert a blank formatted diskette and press `C' key"
      PRINT "If a formatted diskette is not available, press any other key ..."
      A$ = ""
      WHILE A$ = ""
      A$ = INKEY$
      WEND
      IF UCASE$(A$) = "C" THEN GOTO Create.Floppy
      CLS
      PRINT "Please format a diskette and try again ..."
      END
Create.Floppy:
      CLS
      LOCATE 6, 12
      PRINT "Input Drive Letter:";
      DO
          A$ = INPUT$(1)
      LOOP UNTIL A$ = "A" OR A$ = "B"
      AdvDir$ = A$ + ":"
CREATE.FILES:
      DIM MON$(24), ART$(4), Directions$(4)
      CLS
      LOCATE 6, 12
      INPUT "Adventure # ", AdvNo$
      AdvDir$ = AdvDir$ + "Adv#" + RIGHT$("000" + AdvNo$, 3)
      ON ERROR GOTO DirHere
      MKDIR AdvDir$
DirDun:
      ON ERROR GOTO 0
      LOCATE 8, 12
      LINE INPUT "Adventure Title:", Adv$
GET.FILE.NAME:
      LOCATE 10, 1
      LINE INPUT "File Name (8 char max.):", FI.NAME$
      FI.NAME$ = UCASE$(FI.NAME$)
      IF LEN(FI.NAME$) > 8 THEN BEEP: GOTO GET.FILE.NAME
      IF LEFT$(FI.NAME$, 1) < "A" OR LEFT$(FI.NAME$, 1) > "Z" THEN BEEP: GOTO GET.FILE.NAME
      LOCATE 12, 1
      LINE INPUT "Author Name: ", AUTH.NAME$
      OPEN AdvDir$ + "\EAMON.NAM" FOR OUTPUT AS #1
      WRITE #1, FI.NAME$
      WRITE #1, Adv$
      WRITE #1, AUTH.NAME$
      WRITE #1, ADV.NO
      CLOSE 1
      ND = 6
      MAX.RM = 100
      MAX.ART = 100
      MAX.EFF = 100
      MAX.MON = 100
      RM.LEN = 64
      RMN.LEN = 64
      MON.LEN = 128
      ART.LEN = 128
      DESC.LEN = 256
      MON.FLDS = 12
      ART.FLDS = 8
      RM.FLDS = 0
      MN.LEN = 20
      AN.LEN = 20
      GOSUB DISPLAY.CONTROL
      OPEN AdvDir$ + "\DESC.R0" FOR OUTPUT AS #1
      WRITE #1, NR
      WRITE #1, NA
      WRITE #1, NE
      WRITE #1, NM
      WRITE #1, ND
      WRITE #1, MAX.RM
      WRITE #1, MAX.ART
      WRITE #1, MAX.EFF
      WRITE #1, MAX.MON
      WRITE #1, RM.LEN
      WRITE #1, RMN.LEN
      WRITE #1, MON.LEN
      WRITE #1, ART.LEN
      WRITE #1, DESC.LEN
      WRITE #1, MON.FLDS
      WRITE #1, ART.FLDS
      WRITE #1, RM.FLDS
      WRITE #1, MN.LEN
      WRITE #1, AN.LEN
      CLOSE 1
      GOSUB CREATE.ROOMS
      GOSUB CREATE.RMNAMES
      GOSUB CREATE.ARTIFACT
      GOSUB CREATE.MONSTER
      GOSUB CREATE.DESC
      CLS
      LOCATE 10, 10
      PRINT "Dungeon is now ready for editing ..."
      CLOSE
      SHELL "copy ddd\mainpgm.bas " + Path$
      SHELL "copy ddd\leadin.bas " + Path$ + FI.NAME$
      OPEN "DDD\AdvPath.DAT" FOR OUTPUT AS #1
      PRINT #1, AdvDir$
      PRINT #1, Adv$
      CLOSE 1
      RUN "DDD\DUNGEDIT"
DirHere:
      RESUME DirDun
CREATE.ROOMS:  ' ====== OPEN ROOM NAMES FILE ======
      OPEN AdvDir$ + "\ROOMS.TXT" FOR RANDOM AS #1 LEN = RM.LEN
      RETURN
CREATE.RMNAMES:  ' ====== OPEN ROOM NAMES FILE ======
      OPEN AdvDir$ + "\RMNAMES.TXT" FOR RANDOM AS #2 LEN = RMN.LEN
      RETURN
CREATE.ARTIFACT: ' ====== OPEN ARTIFACT FILE ======
      OPEN AdvDir$ + "\ARTIF.TXT" FOR RANDOM AS #3 LEN = ART.LEN
      RETURN
CREATE.MONSTER:
      OPEN AdvDir$ + "\MONST.TXT" FOR RANDOM AS #4 LEN = MON.LEN
      RETURN
CREATE.DESC:  ' ====== OPEN DESC FILE ======
      OPEN AdvDir$ + "\DESC.TXT" FOR RANDOM AS #5 LEN = DESC.LEN
      RETURN
DISPLAY.CONTROL:
      CLS
      PRINT "Control information for this adventure ... IMPORTANT!!! DO NOT PROCEED"
      PRINT "if the information given below is not correct! Press ESC to cancel run."
      LOCATE 4, 10: PRINT "Number of Rooms      ... "; : PRINT USING "###"; NR
      LOCATE 5, 10: PRINT "Number of Artifacts  ... "; : PRINT USING "###"; NA
      LOCATE 6, 10: PRINT "Number of Effects   .... "; : PRINT USING "###"; NE
      LOCATE 7, 10: PRINT "Number of Monsters  .... "; : PRINT USING "###"; NM
      PRINT
      LOCATE 9, 10: PRINT "Number of Directions ... "; : PRINT USING " ##"; ND
      LOCATE 10, 10: PRINT "Maximum Nbr Rooms    ... "; : PRINT USING "###"; MAX.RM
      LOCATE 11, 10: PRINT "Maximum Nbr Artifacts .. "; : PRINT USING "###"; MAX.ART
      LOCATE 12, 10: PRINT "Maximum Nbr Effects .... "; : PRINT USING "###"; MAX.EFF
      LOCATE 13, 10: PRINT "Maximum Nbr Monsters ... "; : PRINT USING "###"; MAX.MON
      LOCATE 14, 10: PRINT "Rooms File Length  ..... "; : PRINT USING " ##"; RM.LEN
      LOCATE 15, 10: PRINT "Room Names Length  ..... "; : PRINT USING " ##"; RMN.LEN
      LOCATE 16, 10: PRINT "Monster File Length  ... "; : PRINT USING "###"; MON.LEN
      LOCATE 17, 10: PRINT "Artifact File Length ... "; : PRINT USING "###"; ART.LEN
      LOCATE 18, 10: PRINT "Description Length ..... "; : PRINT USING "###"; DESC.LEN
      LOCATE 19, 10: PRINT "Nbr Monster Fields ..... "; : PRINT USING "###"; MON.FLDS
      LOCATE 20, 10: PRINT "Nbr Artifact Fields .... "; : PRINT USING "###"; ART.FLDS
      LOCATE 21, 10: PRINT "Nbr Room Fields ........ "; : PRINT USING "###"; RM.FLDS
      LOCATE 22, 10: PRINT "Monster Name Length .... "; : PRINT USING "###"; MN.LEN
      LOCATE 23, 10: PRINT "Artifact Name Length ... "; : PRINT USING "###"; AN.LEN
      GOSUB PRESS.ANY.KEY
      IF ESC THEN GOTO CORRECT.ABORT.RTN
      RETURN
PRESS.ANY.KEY:
      ESC = 0
      A$ = ""
      WHILE A$ = ""
        A$ = INKEY$
        IF A$ = CHR$(27) THEN ESC = -1
      WEND
      RETURN
CORRECT.ABORT.RTN:
      LOCATE 1, 1
      PRINT "You may correct the incorrect values by re-keying them at this time. If you   "
      PRINT "would prefer to abort the program, press the ESC key on any of the values."
      PRINT SPC(79);
EDIT.NR:
      ESC = 0
      LOCATE 4, 35
      FMT$ = "I3"
      DF = NR
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      NEW.NR = I.NUM
EDIT.NA:
      LOCATE 5, 35
      FMT$ = "I3"
      DF = NA
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      NEW.NA = I.NUM
EDIT.NE:
      LOCATE 6, 35
      FMT$ = "I3"
      DF = NE
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      NEW.NE = I.NUM
EDIT.NM:
      LOCATE 7, 35
      FMT$ = "I3"
      DF = NM
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      NEW.NM = I.NUM
EDIT.ND:
      LOCATE 9, 35
      FMT$ = "I3"
      DF = ND
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM <> 6 AND I.NUM <> 10 THEN GOTO EDIT.ND
      NEW.ND = I.NUM
EDIT.MAX.RM:
      LOCATE 10, 35
      FMT$ = "I3"
      DF = MAX.RM
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 50 OR I.NUM > 400 THEN BEEP: GOTO EDIT.MAX.RM
      NEW.MAX.RM = I.NUM
EDIT.MAX.ART:
      LOCATE 11, 35
      FMT$ = "I3"
      DF = MAX.ART
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 50 OR I.NUM > 400 THEN BEEP: GOTO EDIT.MAX.ART
      NEW.MAX.ART = I.NUM
EDIT.MAX.EFF:
      LOCATE 12, 35
      FMT$ = "I3"
      DF = MAX.EFF
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 50 OR I.NUM > 400 THEN BEEP: GOTO EDIT.MAX.EFF
      NEW.MAX.EFF = I.NUM
EDIT.MAX.MON:
      LOCATE 13, 35
      FMT$ = "I3"
      DF = MAX.MON
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 50 OR I.NUM > 400 THEN BEEP: GOTO EDIT.MAX.MON
      NEW.MAX.MON = I.NUM
EDIT.RM.LEN:
      LOCATE 14, 35
      FMT$ = "I3"
      DF = RM.LEN
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 12 OR I.NUM > 128 THEN BEEP: GOTO EDIT.RM.LEN
      NEW.RM.LEN = I.NUM
EDIT.RMN.LEN:
      LOCATE 15, 35
      FMT$ = "I3"
      DF = RMN.LEN
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 36 OR I.NUM > 256 THEN BEEP: GOTO EDIT.RMN.LEN
      NEW.RMN.LEN = I.NUM
EDIT.MON.LEN:
      LOCATE 16, 35
      FMT$ = "I3"
      DF = MON.LEN
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 32 OR I.NUM > 256 THEN BEEP: GOTO EDIT.ART.LEN
      NEW.MON.LEN = I.NUM
EDIT.ART.LEN:
      LOCATE 17, 35
      FMT$ = "I3"
      DF = ART.LEN
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 36 OR I.NUM > 256 THEN BEEP: GOTO EDIT.ART.LEN
      NEW.ART.LEN = I.NUM
EDIT.DESC.LEN:
      LOCATE 18, 35
      FMT$ = "I3"
      DF = DESC.LEN
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 160 OR I.NUM > 1024 THEN PRINT CHR$(7): GOTO EDIT.DESC.LEN
      NEW.DESC.LEN = I.NUM
EDIT.MON.FLDS:
      LOCATE 19, 35
      FMT$ = "I3"
      DF = MON.FLDS
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 12 OR I.NUM > 36 THEN PRINT CHR$(7): GOTO EDIT.MON.FLDS
      NEW.MON.FLDS = I.NUM
EDIT.ART.FLDS:
      LOCATE 20, 35
      FMT$ = "I3"
      DF = ART.FLDS
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 8 OR I.NUM > 12 THEN PRINT CHR$(7): GOTO EDIT.ART.FLDS
      NEW.ART.FLDS = I.NUM
EDIT.RM.FLDS:
      LOCATE 21, 35
      FMT$ = "I3"
      DF = RM.FLDS
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 0 OR I.NUM > 4 THEN PRINT CHR$(7): GOTO EDIT.DESC.LEN
      NEW.RM.FLDS = I.NUM
EDIT.MN.LEN:
      LOCATE 22, 35
      FMT$ = "I3"
      DF = MN.LEN
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 20 OR I.NUM > 64 THEN PRINT CHR$(7): GOTO EDIT.MN.LEN
      NEW.MN.LEN = I.NUM
EDIT.AN.LEN:
      LOCATE 23, 35
      FMT$ = "I3"
      DF = AN.LEN
      GOSUB GET.NUMBER
      IF ESC THEN GOTO FORGET.IT
      IF I.NUM < 20 OR I.NUM > 64 THEN PRINT CHR$(7): GOTO EDIT.AN.LEN
      NEW.AN.LEN = I.NUM
      NR = NEW.NR
      NA = NEW.NA
      NE = NEW.NE
      NM = NEW.NM
      ND = NEW.ND
      MAX.RM = NEW.MAX.RM
      MAX.ART = NEW.MAX.ART
      MAX.EFF = NEW.MAX.EFF
      MAX.MON = NEW.MAX.MON
      RM.LEN = NEW.RM.LEN
      RMN.LEN = NEW.RMN.LEN
      MON.LEN = NEW.MON.LEN
      ART.LEN = NEW.ART.LEN
      DESC.LEN = NEW.DESC.LEN
      MON.FLDS = NEW.MON.FLDS
      ART.FLDS = NEW.ART.FLDS
      RM.FLDS = NEW.RM.FLDS
      MN.LEN = NEW.MN.LEN
      AN.LEN = NEW.AN.LEN
      IF MON.FLDS > 12 THEN GOSUB GET.MON.LBLS
      IF ART.FLDS > 8 THEN GOSUB GET.ART.LBLS
      IF RM.FLDS > 0 THEN GOSUB GET.RM.LBLS
      GOTO DISPLAY.CONTROL
FORGET.IT:
      CLOSE
      END
GET.MON.LBLS:
      CLS
      LOCATE 1, 1
      PRINT "You must define your extra monster field labels below..."
      FOR X = 13 TO MON.FLDS
          LOCATE 3 + X - 12, 4
          INPUT "Field Label:", LBL$
          MON$(X - 12) = LBL$
      NEXT
      OPEN Path$ + "MONST.CTL" FOR OUTPUT AS #1
      FOR D = 13 TO MON.FLDS
          WRITE #1, MON$(X - 12)
      NEXT
      CLOSE 1
      RETURN
GET.ART.LBLS:
      CLS
      LOCATE 1, 1
      PRINT "You must define your extra artifact field labels below..."
      FOR X = 9 TO ART.FLDS
          LOCATE 3 + X - 8, 4
          INPUT "Field Label:", LBL$
          ART$(X - 8) = LBL$
      NEXT
      OPEN Path$ + "ARTIF.CTL" FOR OUTPUT AS #1
      FOR D = 9 TO ART.FLDS
          WRITE #1, ART$(X - 8)
      NEXT
      CLOSE 1
      RETURN
GET.RM.LBLS:
      CLS
      LOCATE 1, 1
      PRINT "You must define your extra Room field labels below..."
      FOR X = 1 TO RM.FLDS
          LOCATE 3 + X, 4
          INPUT "Field Label:", LBL$
          Directions$(X) = LBL$
      NEXT
      OPEN Path$ + "ROOMS.CTL" FOR OUTPUT AS #1
      FOR D = 1 TO RM.FLDS
          WRITE #1, Directions$(X)
      NEXT
      CLOSE 1
      RETURN
GET.NUMBER:   ' Numeric I/O
      I.L% = VAL(MID$(FMT$, 2))
      I.U$ = RIGHT$("###,###,###,###", I.L% + INT((I.L% - 1) / 3))
      I$ = ""
      V% = CSRLIN
      H% = POS(1)
NIO.1:
      LOCATE V%, H%
      IF I$ <> "" THEN
          PRINT USING I.U$; VAL(I$);
      ELSE
          PRINT USING I.U$; DF;
      END IF
NIO.2:
      LOCATE V%, H% + LEN(I.U$) - 1:
      GOSUB GET.BYTE:
      IF A$ = CHR$(13) THEN GOTO NIO.RETURN
      IF A$ = CHR$(27) THEN ESC = -1: GOTO NIO.RETURN2
      IF A$ = CHR$(8) AND LEN(I$) > 0 THEN I$ = LEFT$(I$, LEN(I$) - 1): GOTO NIO.1
      IF A$ = CHR$(8) AND I$ = "" THEN BK = -1: GOTO NIO.RETURN2
      IF A$ = "-" AND LEFT$(I$, 1) <> "-" THEN I$ = "-" + I$: GOTO NIO.1
      IF A$ = "-" THEN I$ = MID$(I$, 2): GOTO NIO.1
      IF A$ >= "0" AND A$ <= "9" AND LEN(I$) < I.L% THEN I$ = I$ + A$: GOTO NIO.1
      PRINT CHR$(7);
      GOTO NIO.2
NIO.RETURN:
      IF I$ = "" THEN I$ = STR$(DF)
      I.NUM = VAL(I$)
      BK = 0
NIO.RETURN2:
      LOCATE , , 0: RETURN
GET.BYTE:  ' get a keystroke & convert to std 1 byte code
      LOCATE , , 1
      A$ = ""
      WHILE A$ = ""
        A$ = INKEY$
      WEND
      IF A$ = CHR$(127) THEN A$ = CHR$(8)
      IF A$ = CHR$(0) + CHR$(75) THEN A$ = CHR$(8)
      IF A$ = CHR$(0) + CHR$(77) THEN A$ = CHR$(21)
      A$ = LEFT$(A$, 1)
      IF CAPS THEN LOCATE , , 0: RETURN
      IF A$ >= "a" THEN A$ = CHR$(ASC(A$) - 32)
      LOCATE , , 0
      RETURN

